"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = collapseAttributeWhitespace;

var _collapseAttributeWhitespace = require("./collapseAttributeWhitespace");

/** Sort values inside list-like attributes (e.g. class, rel) */
function collapseAttributeWhitespace(tree) {
  tree.walk(function (node) {
    if (!node.attrs) {
      return node;
    }

    Object.keys(node.attrs).forEach(function (attrName) {
      var attrNameLower = attrName.toLowerCase();

      if (!_collapseAttributeWhitespace.attributesWithLists.has(attrNameLower)) {
        return;
      }

      var attrValues = node.attrs[attrName].split(/\s/);
      node.attrs[attrName] = attrValues.sort().join(' ');
    });
    return node;
  });
  return tree;
}